
uiCounter = 0;

setInterval(function(){
	uiCounter--;
},100);


$(function(){
	game.startLoadingSounds();
	
	ss = new Image();
	ss.onload = function(){game.imageLoaded = true;};
	ss.src = "img/ss.png";


	$("#canvas").click(function(e){
		if(game.state == "running"){
			var left = e.clientX - $(this).offset().left;
			var top = e.clientY - $(this).offset().top;
			var i = Math.floor(left/tileSize)-playerOffset+player.x;
			var j = Math.floor(top/tileSize)-playerOffset+player.y;
			
			
			game.describe(i,j);
			e.stopPropagation();
		}
	});

	$("html").keydown(function(e){
		k=e.which;

		if(k==27 && (game.state == "ingameOptions" || game.state=="ingameHelp")){
			game.state = "running";
			$("#overlay").hide();
			$("#return-button").hide();
		} 
	
		if(k==27){
			if(game.state == "letter" || game.state == "tutorial1" || game.state == "tutorial2" || game.state == "tutorial3"){
				startGame();
			}
		}

		if(game.state=="running"){
			if(player.statPoints > 0 && e.shiftKey){
				if(k==83){
					player.increaseStat("strength");
					player.drawUI();
					return;
				}else if(k==68){
					player.increaseStat("dexterity");
					player.drawUI();
					return;
				}else if(k==73){
					player.increaseStat("intelligence");
					player.drawUI();
					return;
				}
			}

			if(game.potionMenuOpen && k>=65 && k<=90){
				player.quaffByCode(k);
				if(game.state!="dead"){
					game.openPotionMenu();
				}
				e.preventDefault();
				e.stopPropagation();

				return;
			}

			if(k==87 || k==38 || k==75){
				player.up();
				e.preventDefault();
				e.stopPropagation();
			}
			if(k==83 || k==40 || k==74){
				player.down();
				e.preventDefault();
				e.stopPropagation();
			}
			if(k==65 || k==37 || k==72){
				player.left();
				e.preventDefault();
				e.stopPropagation();
			}
			if(k==68 || k==39 || k==76){
				player.right();
				e.preventDefault();
				e.stopPropagation();
			}


			if(k==190 || k==46){
				game.log("You wait.");
				magic.state="idle";
				player.wait();
			}
			if(k==53 || k==32 || k==12){
				magic.state="idle";
				player.waitTimes(50);
			}
			
			if(magic.forgetState =="idle"){
				if(k==49) magic.cast(magic.learnedSpells[0]);
				if(k==50) magic.cast(magic.learnedSpells[1]);
				if(k==51) magic.cast(magic.learnedSpells[2]);
			}else{
				if(k==49) magic.forgetSpell(magic.learnedSpells[0]);
				if(k==50) magic.forgetSpell(magic.learnedSpells[1]);
				if(k==51) magic.forgetSpell(magic.learnedSpells[2]);
			}
			
			if(k==82){
				var playerTile = player.getTile();
				if(playerTile.item!=null && playerTile.item.type=="book"){
					playerTile.item.read();
				}
			}
			
			if(k==84){
				player.takeStairs();
			}
			
			if(k==80){
				game.openPotionMenu();
			}
			
			if(k==79){
				$("#return-button").show();
				$("#exit-game").show();
				game.state = "ingameOptions";
				overlay("options-screen");
			}
			
			if(k==191){
				$("#return-button").show();
				game.state = "ingameHelp";
				overlay("help-screen");
			}
			
			if(k==70){
				forgive();
			}
			
			
			if(k==69) player.e();
			
			//if(k==112) game.closeMenu();
			
			if(k==27){
				game.closeMenu();
				if(magic.state != "idle"){
					magic.state="idle";
					game.log("Okay then.");
				}
				
				if(magic.forgetState !="idle"){
					magic.forgetState="idle";
					game.log("Nevermind.");
				}
			}
		}else if(game.state=="dead" || game.state=="won"){
			if(k==89){
				titleScreen();
			}else if(k==82){
				startGame();
			}
		}
		
		
		
		e.stopPropagation();
	});
	
	$("#modal").click(function(e){
		if(game.state=="running"){
			game.closeMenu();
			e.preventDefault();
			e.stopPropagation();
		}
	});
	
	$("html").click(function(e){
		if(game.state=="running"){
			game.closeMenu();
		}
	});
	
	$(".stat-button").click(function(e){
		if(game.state=="running"){
			var stat = $(this)[0].dataset.stat;
			player.increaseStat(stat);
			player.drawUI();
		}
	});
	
	$("#button-container").on("click","#potion-button",function(e){
		if(game.state=="running"){
			game.openPotionMenu();
			e.stopPropagation();
		}
	});
	
	$("#button-container").on("click","#staircase-button",function(e){
		if(game.state=="running"){
			player.takeStairs();
			e.stopPropagation();
		}
	});
	
	$("#button-container").on("click","#e-button",function(e){
		if(game.state=="running"){
			player.e();
			e.stopPropagation();
		}
	});
	
	
	$("#button-container").on("click","#forgive-button",function(e){
		if(game.state=="running"){
			forgive();
			e.stopPropagation();
		}
	});
	
	$("#button-container").on("click","#read-button",function(e){
		if(game.state=="running"){
			var playerTile = player.getTile();
			if(playerTile.item!=null && playerTile.item.type=="book"){
				playerTile.item.read();
			}
			
			e.stopPropagation();
		}
	});

	$("#modal").on("click",".potion-list-name",function(e){
		if(game.state=="running"){
			var potion = $(this)[0].dataset.potion;
			game.describePotion(potion);

			e.preventDefault();
			e.stopPropagation();
		}
	});
	
	$("#modal").on("click",".potion-button",function(e){
		if(game.state=="running"){
			var potion = $(this)[0].dataset.potion;
			player.quaffPotion(potion);
			//$("#modal").hide();
			
			if(game.state!="dead"){
				game.openPotionMenu();
			}
			
			e.preventDefault();
			e.stopPropagation();
		}
	});
	
	$("#button-container").on("click",".magic-button",function(){
		if(game.state=="running"){
			var spell = $(this)[0].dataset.spell;
			if(magic.forgetState =="idle"){
				magic.cast(spell);
			}else{
				magic.forgetSpell(spell);
			}
		}
	});
	
	
	
	
	//start
	$("#start-button").click(function(e){
		openingLetter();
		game.replaceMusic();
		e.stopPropagation();
	});
	
	$("#options-button").click(function(e){
		$("#exit-game").hide();
		gameOptions();
		e.stopPropagation();
	});
	
	$("#help-button").click(function(e){
		showHelp();
		e.stopPropagation();
	});
	
	$("#button-container").on("click","#ingame-options-button",function(e){
		if(game.state=="running"){
			$("#return-button").show();
			uiCounter=2;
			$("#exit-game").show();
			overlay("options-screen");
			game.state = "ingameOptions";
			e.stopPropagation();
		}
	});
	
	$("#button-container").on("click","#ingame-help-button",function(e){
		if(game.state=="running"){
			$("#return-button").show();
			uiCounter=2;
			overlay("help-screen");
			game.state = "ingameHelp";
			e.stopPropagation();
		}
	});

	
	
	

	$("html").on("click keydown",function(e){
		if(game.state == "letter"){
			tutorial1();
		}else if(game.state == "tutorial1"){
			tutorial2();
		}else if(game.state == "tutorial2"){
			tutorial3();
		}else if(game.state == "tutorial3"){
			startGame();
		}
		
		if((game.state==="options" && e.which == 27) || game.state ==="help"){
			titleScreen();
			$("#return-button").hide();
		}
	});
	
	$("html").on("click",function(e){
		if(game.state=="ingameHelp"){
			if(uiCounter<=0){
				game.state = "running";
				$("#overlay").hide();
				$("#return-button").hide();
			}
		}
	});
	
	
	$("#return-button").click(function(e){
		if(game.state==="options" || game.state ==="help"){
			titleScreen();
		}else if(game.state == "ingameOptions" || game.state=="ingameHelp"){
			game.state = "running";
			$("#overlay").hide();
		}

		$("#return-button").hide();
	});
	
	

	
	$("#exit-game").click(function(e){
		if(confirm("Are you sure you want to quit? All progress will be lost.")){
			titleScreen();
		}
	});
	
	$("#volume-control").change(function(e){
		var newVolume = $("#volume-control").val();
		game.setVolume(newVolume/20);

		game.playSound("gold");

		e.preventDefault();
		e.stopPropagation();
	});

	$("#music-volume-control").change(function(e){
		var newVolume = $("#music-volume-control").val();
		game.setMusicVolume(newVolume/20);

		game.playSound("gold");

		e.preventDefault();
		e.stopPropagation();
	});
	
	
	
	
	
	

	//todo: load assets
	
	
	resizeHandler(true);
	
	//
	
	
	$(window).resize(resizeHandler);
	
	$("#loading-screen p").show();
	
	loadingTimer = setInterval(function(){
		if(game.loadingComplete()){
			if(game.debug){
				//startGame();
				titleScreen();
			}else{
				titleScreen();
			}
			clearInterval(loadingTimer);
		}
	},50);


});


playerOffset = 5;
canvasTiles = 11;

function resizeHandler(skipDraw){
	var w = $(window).width();
	var h = $(window).height();
	
	$("#button-container,#stats,#console,#overlay-inner,#sidebar").removeClass();
	
	
	$(".overlay-screen").removeClass("overlay-large overlay-medium overlay-small");
	
	//resolutions:
	//1210x710
	//980x530
	//800x360
	
	if(w >=1210 && h >= 710){
		tileScaling = 4;
		
		$("#button-container").addClass("button-large");
		$("#console").addClass("console-large");
		$(".ui-spacer").height(15);
		$("#stats").addClass("table-large");
		$(".overlay-screen").addClass("overlay-large");
		$("#overlay-inner").addClass("overlay-inner-large");
		$("#sidebar").addClass("sidebar-large");

		mapTileSize = 5;
	}else if(w >=980 && h >= 530){
		tileScaling = 3;
		
		$("#button-container").addClass("button-medium");
		$("#console").addClass("console-medium");
		$(".ui-spacer").height(5);
		$("#stats").addClass("table-medium");
		$(".overlay-screen").addClass("overlay-medium");
		$("#overlay-inner").addClass("overlay-inner-medium");
		$("#sidebar").addClass("sidebar-medium");
		
		mapTileSize = 4;
	}else{
		tileScaling = 2;

		$("#button-container").addClass("button-small");
		$("#console").addClass("console-small");
		$(".ui-spacer").height(0);
		$("#stats").addClass("table-small");
		$(".overlay-screen").addClass("overlay-small");
		$("#overlay-inner").addClass("overlay-inner-small");
		$("#sidebar").addClass("sidebar-small");
		
		mapTileSize = 2;
	}

	
	$("#map").attr("width",mapTileSize*50);
	$("#map").attr("height",mapTileSize*50);
	
	
	tileSize = 16*tileScaling;
	
	
	var canvasSize = canvasTiles*tileSize;
	
	$("#canvas").attr("width",canvasSize);
	$("#canvas").attr("height",canvasSize);
	
	$("#canvas-container").css({
		width: canvasSize + 'px',
		height: canvasSize + 'px'
	});
	
	$("#modal").css({
		height: (canvasSize-50) + 'px',
		"margin-top": -1*Math.floor((canvasSize-50)/2)+'px'
	});

	
	
	
	$("#outer").css({
		width: (496+canvasSize+4)+'px',
		height: canvasSize + 4 + 'px',
		"margin-left": -1*Math.floor((496+canvasSize)/2) + 'px',
		"margin-top": -1*Math.floor(canvasSize/2) + 'px'
	});
	
	
	

	ctx = $("#canvas")[0].getContext("2d");
	ctx.webkitImageSmoothingEnabled = false;
	ctx.mozImageSmoothingEnabled = false;
	
	mapCtx = $("#map")[0].getContext("2d");
	mapCtx.webkitImageSmoothingEnabled = false;
	mapCtx.mozImageSmoothingEnabled = false;
	
	
	if(skipDraw!=true && game.state == "running"){
		drawCanvas();
	}
}

function startGame(){
	//todo: clean up!!
	
	potions.init();
	player.init();
	magic.init();
	game.init();
	map.init();
	
	map.generateAllLevels();

	if(game.debug){
		map.levelIndex = 6;
		player.x = 2;
		player.y = 2;
		game.time+=23*60;
	}
	
	game.tick(0);
	game.tick(0);
	
	game.state = "running";
	
	//game.playSound("chaos");
	
	
	game.replaceMusic("dungeon1");

	$("#overlay").hide();
}

function overlay(overlayId){
	$(".overlay-screen").hide();
	$("#overlay").show();
	$("#"+overlayId).fadeIn({duration:1300});
}

function titleScreen(){
	game.state = "title";

	//game.stopSound("chaos");
	game.replaceMusic("title");
	
				
	game.updateScores();
	overlay("title-screen");
}

function openingLetter(){
	game.state = "letter";
	overlay("opening-letter");
}

function tutorial1(){
	game.state = "tutorial1";
	overlay("tutorial1-screen");
}

function tutorial2(){
	game.state = "tutorial2";
	overlay("tutorial2-screen");
}

function tutorial3(){
	game.state = "tutorial3";
	overlay("tutorial3-screen");
}

function gameOptions(){
	game.state = "options";
	$("#return-button").show();
	overlay("options-screen");
}

function showHelp(){
	game.state = "help";
	$("#return-button").show();
	overlay("help-screen");
}

function forgive(){
	if(game.state=="running" && game.forgivyTime){
		game.log("You've forgiven FANE.");
		game.state = "won";
				
		player.gameOver(true);
	}
}



function drawCanvas(){
	ctx.clearRect(0,0,1000,1000);
	
	player.fov();
	
	//draw level
	map.draw();
	
	//draw player
	player.draw();
	
	map.drawSunlight();
	
	//remove effects
	for(var i=0;i<map.getCurrentLevel().levelSize;i++){
		for(var j=0;j<map.getCurrentLevel().levelSize;j++){
			var tile = map.getTile(i,j);
			tile.effects = [];
		}
	}
	
	map.drawMap();

	player.drawUI();	
}

function ssLocation(index){
	return [(index%16)*16,16*Math.floor(index/16)];
}